<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Folha\Facade\Relatorios;

/**
 * Description of ControleEntregaEPI
 *
 * @author phillipesilva
 */
class ControleEntregaEPI {
    public static function verificaFields() {
        $fields = tk_get_all_fields();

        if (is_null($fields['REPORT_NAME']['']) || $fields['REPORT_NAME'][''] == '') {
            tk_abort(tk_get_message_by_name('msg_SemRelatorioEntregaEPI'));
        }
        if (is_null($fields['DATAREPORT']['']) || $fields['DATAREPORT'][''] == '') {
            tk_abort(tk_get_message_by_name('msg_DataRelatorioEntregaEPI'));
        }

        //Validar Campos que são baseados na Ordem
        switch ($fields['DSORDEM']['']) {
            case 'ALFABETICA':
                if ((is_null($fields['NOME_INICIAL']['']) || $fields['NOME_INICIAL'][''] == '') ||
                    (is_null($fields['NOME_FINAL']['']) || $fields['NOME_FINAL'][''] == '')) {
                    tk_abort(tk_get_message_by_name('msg_NomesRelatorioEntregaEPI'));
                }
                break;
            case 'DATA_ADMISSAO':
                if ((is_null($fields['DT_ADMISSAO_INI']['']) || $fields['DT_ADMISSAO_INI'][''] == '') ||
                    (is_null($fields['DT_ADMISSAO_FIM']['']) || $fields['DT_ADMISSAO_FIM'][''] == '')) {
                    tk_abort(tk_get_message_by_name('msg_DtAdmissaoRelatorioEntregaEPI'));
                }
                break;
            case 'MATRICULA':
                if ((is_null($fields['MATRICULA_INI']['']) || $fields['MATRICULA_INI'][''] == '') ||
                    (is_null($fields['MATRICULA_FIM']['']) || $fields['MATRICULA_FIM'][''] == '')) {
                    tk_abort(tk_get_message_by_name('msg_MatriculaRelatorioEntregaEPI'));
                }
                break;
            case 'ESTRUTURA':
                if ((is_null($fields['ESTRUTURA_LEGAL']['']) || $fields['ESTRUTURA_LEGAL'][''] == '')) {
                    tk_abort(tk_get_message_by_name('msg_EstruturaRelatorioEntregaEPI'));
                }
                break;
            default:
                tk_abort(tk_get_message_by_name('msg_OrdemRelatorioEntregaEPI'));
                break;
        }
    }
}
