<?php
namespace Planejamento\Repositories;

class Cnfdistembserv extends \Doctrine\ORM\EntityRepository
{

    public static function InsereEmbalagem($nrcnfdistembserv,$cdfilial,$cdservfili,$cdcliente,$cddestfili,
                                           $cdcnfdistembserv,$cdcontainer,$nrgrupo, $nrseqcnfcard){
        $sql = <<<SQL
INSERT INTO CNFDISTEMBSERV
(NRCNFDISTEMBSERV, CDFILIAL, CDSERVFILI, CDCLIENTE,
 CDDESTFILI, CDCNFDISTEMBSERV, CDCONTAINER, NRGRUPO, NRSEQCNFCARD)
VALUES
(:NRCNFDISTEMBSERV, :CDFILIAL, :CDSERVFILI, :CDCLIENTE,
 :CDDESTFILI, :CDCNFDISTEMBSERV, :CDCONTAINER, :NRGRUPO, :NRSEQCNFCARD)
SQL;
        $params = array(
            'NRCNFDISTEMBSERV' => $nrcnfdistembserv,
            'CDFILIAL' =>$cdfilial,
            'CDSERVFILI'    =>$cdservfili,
            'CDCLIENTE'     =>$cdcliente,
            'CDDESTFILI'    =>$cddestfili,
            'CDCNFDISTEMBSERV' =>$cdcnfdistembserv,
            'CDCONTAINER'   =>$cdcontainer,
            'NRGRUPO'       =>$nrgrupo,
            'NRSEQCNFCARD'  =>$nrseqcnfcard
        );

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function GetNrGrupo($nrcnfdistemb, $cdfilial, $cdservfili, $cdcliente, $cddestino){
        $sql = <<<SQL
SELECT NRGRUPO
FROM CNFDISTEMBSERV
WHERE NRCNFDISTEMBSERV =:NRCNF
AND CDFILIAL           =:CDFILIAL
AND CDSERVFILI         =:CDSERVFILI
AND (CDCLIENTE =:CDCLIENTE OR CDCLIENTE IS NULL)
AND (CDDESTFILI =:CDDESTFILI OR CDDESTFILI IS NULL)

SQL;
        $params = array(
            'NRCNF' =>$nrcnfdistemb,
            'CDFILIAL' =>$cdfilial,
            'CDSERVFILI' =>$cdservfili,
            'CDCLIENTE'=>$cdcliente,
            'CDDESTFILI'=>$cddestino);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function GetMaxNrgrupo($cdfilial, $cdservfili){
        $sql = <<<SQL
SELECT MAX(NRGRUPO) AS NRGRUPO FROM CNFDISTEMBSERV
WHERE CDFILIAL           =:CDFILIAL
AND CDSERVFILI         =:CDSERVFILI

SQL;
        $params = array(
            'CDFILIAL' =>$cdfilial,
            'CDSERVFILI' =>$cdservfili);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function GetMaxNrgrupoPontoEntrega($cdfilial, $cdservfili, $cdcliente, $cddestfili){
        $sql = <<<SQL
SELECT MAX(NRGRUPO) AS NRGRUPO FROM CNFDISTEMBSERV
WHERE CDFILIAL           =:CDFILIAL
AND CDSERVFILI         =:CDSERVFILI
AND (CDCLIENTE =:CDCLIENTE)
AND (CDDESTFILI =:CDDESTFILI)

SQL;
        $params = array(
            'CDFILIAL' =>$cdfilial,
            'CDSERVFILI' =>$cdservfili,
            'CDCLIENTE' =>$cdcliente,
            'CDDESTFILI' =>$cddestfili);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function DeletaEmbalagem($cdfilial, $cdservfili, $cddestfili, $cdcliente, $nrgrupo){
        $sql = <<<SQL
DELETE FROM CNFDISTEMBSERV
WHERE CDFILIAL = :P_CDFILIAL AND
      CDSERVFILI = :P_CDSERVFILI AND
      (((:P_CDCLIENTE IS NULL) AND (CDCLIENTE IS NULL)) OR
       (CDCLIENTE = :P_CDCLIENTE AND CDDESTFILI = :P_CDDESTFILI)) AND
      (NRGRUPO = :P_NRGRUPO)
SQL;
        $params = array(
            'P_CDFILIAL' =>$cdfilial,
            'P_CDSERVFILI'    =>$cdservfili,
            'P_CDDESTFILI'    =>$cddestfili,
            'P_CDCLIENTE'     =>$cdcliente,
            'P_NRGRUPO'       =>$nrgrupo
        );

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function BuscaPratoRelacionado($cdfilial, $cdservfili, $nrseqcnfcard, $cdcliente, $cddestfili){
        $sql = <<<SQL
SELECT DISTINCT CDFILIAL, CDSERVFILI,  NRCNFDISTEMBSERV,
  NRSEQCNFCARD, CDCLIENTE, CDDESTFILI
FROM CNFDISTEMBSERV
WHERE CDFILIAL  =:CDFILIAL
AND (CDCLIENTE =:CDCLIENTE OR CDCLIENTE IS NULL)
AND (CDDESTFILI =:CDDESTFILI OR CDDESTFILI IS NULL)
AND CDSERVFILI  =:CDSERVFILI
AND NRSEQCNFCARD =:NRSEQCNFCARD

SQL;
        $params = array(
            'CDFILIAL'     =>$cdfilial,
            'CDSERVFILI'   =>$cdservfili,
            'NRSEQCNFCARD' =>$nrseqcnfcard,
            'CDCLIENTE'    =>$cdcliente,
            'CDDESTFILI'   =>$cddestfili);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function BuscaPratoRelacionadoPontoEntrega($cdfilial, $cdservfili, $nrseqcnfcard, $cdcliente, $cddestfili){
        $sql = <<<SQL
SELECT DISTINCT CDFILIAL, CDSERVFILI,  NRCNFDISTEMBSERV,
  NRSEQCNFCARD, CDCLIENTE, CDDESTFILI
FROM CNFDISTEMBSERV
WHERE CDFILIAL  =:CDFILIAL
AND (CDCLIENTE =:CDCLIENTE)
AND (CDDESTFILI =:CDDESTFILI)
AND CDSERVFILI  =:CDSERVFILI
AND NRSEQCNFCARD =:NRSEQCNFCARD
SQL;
        $params = array(
            'CDFILIAL'     =>$cdfilial,
            'CDSERVFILI'   =>$cdservfili,
            'NRSEQCNFCARD' =>$nrseqcnfcard,
            'CDCLIENTE'    =>$cdcliente,
            'CDDESTFILI'   =>$cddestfili);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function UpdateDistribuicaoServico($nrcnfdistembserv , $cdcontainer, $nrgrupo, $nrseqprat){
        $sql = <<<SQL
DELETE FROM CNFDISTEMBSERV
WHERE NRCNFDISTEMBSERV ='$nrcnfdistembserv'

SQL;
        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }


    }

    public static function ConfereConfiguracaoInserida($cdfilial, $cdservfili, $cdcliente, $cddestfili, $cdcnf, $nrgrupo){
        $sql =<<<SQL
SELECT CDFILIAL, CDSERVFILI, CDCLIENTE, CDDESTFILI, CDCNFDISTEMBSERV, NRGRUPO FROM CNFDISTEMBSERV
WHERE CDFILIAL =:CDFILIAL AND
CDSERVFILI =:CDSERVFILI
AND (CDCLIENTE =:CDCLIENTE OR CDCLIENTE IS NULL)
AND (CDDESTFILI =:CDDESTFILI OR CDDESTFILI IS NULL) AND
CDCNFDISTEMBSERV =:CDCNFDISTEMBSERV AND
NRGRUPO =:NRGRUPO
SQL;
        $params = array(
            'CDFILIAL'     =>$cdfilial,
            'CDSERVFILI'   =>$cdservfili,
            'CDCLIENTE'    =>$cdcliente,
            'CDDESTFILI'   =>$cddestfili,
            'CDCNFDISTEMBSERV' =>$cdcnf,
            'NRGRUPO' =>$nrgrupo);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }


    }

    public static function BuscaDistribuicao($cdfilial, $cdservfili, $cdcliente, $cddestfili){
        $sql = <<<SQL
SELECT CNF.NRCNFDISTEMBSERV, C.NRSEQCNFCARD, CNF.CDCNFDISTEMBSERV
  FROM CONFCARD C
       LEFT JOIN CNFDISTEMBSERV CNF ON CNF.NRSEQCNFCARD = C.NRSEQCNFCARD AND
                                    CNF.CDFILIAL = C.CDFILIAL AND
                                    CNF.CDSERVFILI = C.CDSERVFILI AND
                                    ( ((:P_CDCLIENTE IS NULL) AND (CNF.CDCLIENTE IS NULL)) OR
	                                  (CNF.CDCLIENTE = :P_CDCLIENTE AND
	                                   CNF.CDDESTFILI = :P_CDDESTFILI) )

 WHERE C.CDFILIAL = :P_CDFILIAL
   AND C.CDSERVFILI = :P_CDSERVFILI
   AND CNF.NRCNFDISTEMBSERV IS NOT NULL
ORDER BY CDTIPOPRAT, NRORDCNFCARD
SQL;
        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_CDSERVFILI' => $cdservfili,
            'P_CDCLIENTE' => $cdcliente,
            'P_CDDESTFILI'=> $cddestfili
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }


    }

    public static function BuscaDistribuicaoEspecificaTipoprat($cdfilial, $cdservfili, $cdcliente, $cddestfili, $cdtipoprat){
        $sql =<<<SQL
SELECT C.NRSEQCNFCARD, C.NRORDCNFCARD, C.CDTIPOPRAT, CNF.NRCNFDISTEMBSERV,
       CNF.CDCNFDISTEMBSERV, CNF.CDCONTAINER, CNF.NRGRUPO
  FROM CONFCARD C
       LEFT JOIN CNFDISTEMBSERV CNF ON CNF.NRSEQCNFCARD = C.NRSEQCNFCARD AND
                                    CNF.CDFILIAL = C.CDFILIAL AND
                                    CNF.CDSERVFILI = C.CDSERVFILI AND
                                    ( ((:P_CDCLIENTE IS NULL) AND (CNF.CDCLIENTE IS NULL)) OR
	                                  (CNF.CDCLIENTE = :P_CDCLIENTE AND
	                                   CNF.CDDESTFILI = :P_CDDESTFILI) )

 WHERE C.CDFILIAL = :P_CDFILIAL
   AND C.CDSERVFILI = :P_CDSERVFILI
   AND C.CDTIPOPRAT = :P_CDTIPOPRAT


ORDER BY CDTIPOPRAT, NRORDCNFCARD
SQL;
        $params = array(
            'P_CDFILIAL' => $cdfilial,
            'P_CDSERVFILI' => $cdservfili,
            'P_CDCLIENTE' => $cdcliente,
            'P_CDDESTFILI'=> $cddestfili,
            'P_CDTIPOPRAT'=>$cdtipoprat
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function DeletaDistribuicaoConfcard($cdfilial, $cdservfili, $cdcliente, $cddestfili, $nrseqprat){
        $sql = <<<SQL
DELETE FROM CNFDISTEMBSERV
WHERE CDFILIAL ='$cdfilial' AND
      CDSERVFILI = '$cdservfili' AND
      ((('$cdcliente' IS NULL) AND (CDCLIENTE IS NULL)) OR
       (CDCLIENTE = '$cdcliente' AND CDDESTFILI = '$cddestfili')) AND
      NRSEQCNFCARD = '$nrseqprat'
SQL;
        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function InsereConfiguracaoDistribuicao($nrcnfdistembserv, $cdfilial, $cdservfili, $cdcliente, $cddestfili,
                                                          $cdcnfdistembserv, $cdcontainer, $nrgrupo, $nrseqcnfcard){
        $sql = <<<SQL
INSERT INTO CNFDISTEMBSERV
(NRCNFDISTEMBSERV, CDFILIAL, CDSERVFILI, CDCLIENTE,
 CDDESTFILI, CDCNFDISTEMBSERV, CDCONTAINER, NRGRUPO, NRSEQCNFCARD)
VALUES
(:NRCNFDISTEMBSERV, :CDFILIAL, :CDSERVFILI, :CDCLIENTE,
 :CDDESTFILI, :CDCNFDISTEMBSERV, :CDCONTAINER, :NRGRUPO, :NRSEQCNFCARD)
SQL;

        $params = array(
            'NRCNFDISTEMBSERV' =>$nrcnfdistembserv,
            'CDFILIAL'=>$cdfilial,
            'CDSERVFILI'=>$cdservfili,
            'CDCLIENTE'=>$cdcliente,
            'CDDESTFILI'=>$cddestfili,
            'CDCNFDISTEMBSERV'=>$cdcnfdistembserv,
            'CDCONTAINER'=>$cdcontainer,
            'NRGRUPO'=>$nrgrupo,
            'NRSEQCNFCARD'=>$nrseqcnfcard
        );

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    public static function BuscaConfiguracaoDistribuicaoRealizada($cdfilial, $cdservfili, $cdcliente, $cddestfili){
        $sql= <<<SQL
        SELECT CNF.NRCNFDISTEMBSERV,
  CNF.NRSEQCNFCARD,
  CNF.CDCNFDISTEMBSERV, CNF.NRGRUPO, C.CDTIPOPRAT
FROM CONFCARD C
LEFT JOIN CNFDISTEMBSERV CNF
ON CNF.NRSEQCNFCARD   = C.NRSEQCNFCARD
AND CNF.CDFILIAL      = C.CDFILIAL
AND CNF.CDSERVFILI    = C.CDSERVFILI
AND ( ((:P_CDCLIENTE IS NULL)
AND (CNF.CDCLIENTE   IS NULL))
OR (CNF.CDCLIENTE     = :P_CDCLIENTE
AND CNF.CDDESTFILI    = :P_CDDESTFILI) )
WHERE C.CDFILIAL      = :P_CDFILIAL
AND C.CDSERVFILI      = :P_CDSERVFILI
AND CNF.CDCONTAINER  IS NOT NULL
ORDER BY CDTIPOPRAT,
  NRORDCNFCARD
SQL;

        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_CDSERVFILI'=>$cdservfili,
            'P_CDCLIENTE'=>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function BuscaConfiguracaoDistribuicaoNaoRealizada($cdfilial, $cdservfili, $cdcliente, $cddestfili){
        $sql= <<<SQL
        SELECT CNF.NRCNFDISTEMBSERV, C.NRSEQCNFCARD, CNF.CDCNFDISTEMBSERV, C.CDTIPOPRAT
  FROM CONFCARD C
       LEFT JOIN CNFDISTEMBSERV CNF ON CNF.NRSEQCNFCARD = C.NRSEQCNFCARD AND
                                    CNF.CDFILIAL = C.CDFILIAL AND
                                    CNF.CDSERVFILI = C.CDSERVFILI AND
                                    ( ((:P_CDCLIENTE IS NULL) AND (CNF.CDCLIENTE IS NULL)) OR
	                                  (CNF.CDCLIENTE = :P_CDCLIENTE AND
	                                   CNF.CDDESTFILI = :P_CDDESTFILI) )

 WHERE C.CDFILIAL = :P_CDFILIAL
   AND C.CDSERVFILI = :P_CDSERVFILI
    AND CNF.CDCONTAINER IS NULL
ORDER BY CDTIPOPRAT, NRORDCNFCARD
SQL;

        $params = array(
            'P_CDFILIAL'=>$cdfilial,
            'P_CDSERVFILI'=>$cdservfili,
            'P_CDCLIENTE'=>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili
        );

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    public static function BuscaEmbalagemConfigurada($cdfilial, $cdservfili, $cdcliente, $cddestfili, $nrgrupo){

        $sql = <<<SQL
SELECT CD.CDCNFDISTEMBSERV,
  CD.NRGRUPO,
  C.NRORDCNFCARD,
  C.NRSEQCNFCARD AS NRSEQCNFCARD,
  C.CDTIPOPRAT   AS CDTIPOPRAT,
  T.NMTIPOPRAT   AS NMTIPOPRAT
FROM CNFDISTEMBSERV CD
INNER JOIN CONFCARD C
ON CD.CDFILIAL      = C.CDFILIAL
AND CD.CDSERVFILI   = C.CDSERVFILI
AND CD.NRSEQCNFCARD = C.NRSEQCNFCARD
INNER JOIN TIPOPRAT T
ON T.CDTIPOPRAT    = C.CDTIPOPRAT
WHERE C.CDFILIAL   = '$cdfilial'
AND C.CDSERVFILI   = '$cdservfili'
AND ((('$cdcliente' IS NULL)
AND (CD.CDCLIENTE IS NULL)) OR
('$cdcliente' = CD.CDCLIENTE)
AND ('$cddestfili' = CD.CDDESTFILI))
AND CD.NRGRUPO     ='$nrgrupo'
SQL;

        $params = array(
            'CDFILIAL' =>$cdfilial,
            'CDSERVFILI' =>$cdservfili,
            'CDCLIENTE' =>$cdcliente,
            'CDDESTFILI'=>$cddestfili,
            'NRGRUPO'=>$nrgrupo);

        try {
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

        return $sql;

    }

    public static function BuscaNrdistembserv($cdfilial, $cdservfili, $cdcliente, $cddestfili, $nrgrupo, $dist, $distr){
        $sql = <<<SQL
SELECT DISTINCT  CNFDISTEMBSERV.NRCNFDISTEMBSERV, C.CDCONTAINER AS CDCONTAINER,
				CASE WHEN C.IDPROPOSITO = 'C' THEN 'N' ELSE 'S' END AS VARIOSTPPRAT,
				CASE CNFDISTEMBSERV.CDCNFDISTEMBSERV WHEN 'DIST' THEN :P_DIST WHEN 'DISTR' THEN :P_DISTR ELSE C.NMCONTAINER END AS NMCONTAINER
FROM CNFDISTEMBSERV
	 LEFT JOIN CONTAINER C ON C.CDCONTAINER = CNFDISTEMBSERV.CDCONTAINER
WHERE CNFDISTEMBSERV.CDFILIAL = :P_CDFILIAL AND
	  CNFDISTEMBSERV.CDSERVFILI = :P_CDSERVFILI AND
	  CNFDISTEMBSERV.NRGRUPO    = :P_NRGRUPO AND
	  (((:P_CDCLIENTE IS NULL) AND (CNFDISTEMBSERV.CDCLIENTE IS NULL)) OR
	(:P_CDCLIENTE = CNFDISTEMBSERV.CDCLIENTE) AND (:P_CDDESTFILI = CNFDISTEMBSERV.CDDESTFILI))
SQL;

        $params = array(
            'P_DIST'=>$dist,
            'P_DISTR'=>$distr,
            'P_CDFILIAL' =>$cdfilial,
            'P_CDSERVFILI' =>$cdservfili,
            'P_CDCLIENTE' =>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili,
            'P_NRGRUPO'=>$nrgrupo);

        try {
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

        return $sql;

    }

    public static function deletaDistribuicaoCompleta($cdfilial, $cdservfili){
        $sql = <<<SQL
DELETE FROM CNFDISTEMBSERV
WHERE CDFILIAL = '$cdfilial' AND
      CDSERVFILI = '$cdservfili'

SQL;
        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql);
        } catch (\Exception $e) {
            throw $e;
        }

        return $sql;

    }






}